' mandelbrot-s8p24.spin

con
  _clkmode = xtal1+pll16x
  _clkfreq = 80_000_000

  xmin=round(-2.1*float(1<<24))
  xmax=round( 0.7*float(1<<24))

  ymin=round(-1.2*float(1<<24))
  ymax=round( 1.2*float(1<<24))

  maxiter=32

  MPX=79 ' 0..MPX
  MPY=24 ' 0..MPY

  dx=(xmax-xmin)/MPX
  dy=(ymax-ymin)/MPY

  c4=4<<24

obj
  ser : "microserial.spin"

pub main | c,cx,cy,x,y,x2,y2,iter,px,py

  ser.start(31,30,0,19200)

  cy:=ymin
  repeat py from 0 to MPY
    cx:=xmin
    repeat px from 0 to MPX
      x:=0
      y:=0
      iter:=0
      repeat while iter=<maxiter
        x2:=(x**x)<<8 | (x*x)>>24 ' x*x
        y2:=(y**y)<<8 | (y*y)>>24 ' y*y
        if x2+y2>c4
          quit
        y:=((x**y)<<9 | (x*y)>>23)+cy ' 2*x*y+cy
        x:=x2-y2+cx
        iter+=1
      cx+=dx
      ser.tx(iter+32)
    cy+=dy
    ser.tx(13)
    ser.tx(10)

  waitcnt(_clkfreq+cnt)
  ser.stop
